package
{
	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxObject;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	
	public class Player extends FlxObject
	{
		public var animation:Array;
		
		public const constanimation:Array = 
			[
				[//frame 1
					[0,1],
					[0,2],
					[0,3],
					
					[1,1],
					[1,2],
					[1,3],
					
					[2,1],
					[2,2],
					[2,3],
					
					[3,1],
					[3,2],
					[3,3],
					
					[4,1],
					[4,2],
					[4,3],
					
					[5,1],
					[5,2],
					[5,3],
					
					[6,1],
					[6,2],
					[6,3],
					
					[7,1],
					[7,2],
					
					[8,1],
					[8,2],
					
					[9,1],
					[9,2],
					
					[10,0],
					
					[11,0],				
				],
				
				[//frame 2
					[0,1],
					[0,2],
					[0,3],
					
					[1,1],
					[1,2],
					[1,3],
					
					[2,1],
					[2,2],
					[2,3],
					
					[3,1],
					[3,2],
					[3,3],
					
					[4,1],
					[4,2],
					[4,3],
					
					[5,1],
					[5,2],
					[5,3],
					
					[6,1],
					[6,2],
					[6,3],
					
					[7,1],
					[7,2],
					
					[8,1],
					[8,2],
					
					[9,1],
					[9,2],
					
					[10,1],
					
					[11,0],				
				],
				
				[//frame 3
					[0,1],
					[0,2],
					[0,3],
					
					[1,1],
					[1,2],
					[1,3],
					
					[2,1],
					[2,2],
					[2,3],
					
					[3,1],
					[3,2],
					[3,3],
					
					[4,1],
					[4,2],
					[4,3],
					
					[5,1],
					[5,2],
					[5,3],
					
					[6,1],
					[6,2],
					[6,3],
					
					[7,1],
					[7,2],
					
					[8,1],
					[8,2],
					
					[9,1],
					[9,2],
					
					[10,2],
					
					[11,2],				
				],
				
				[//frame 4
					[0,1],
					[0,2],
					[0,3],
					
					[1,1],
					[1,2],
					[1,3],
					
					[2,1],
					[2,2],
					[2,3],
					
					[3,1],
					[3,2],
					[3,3],
					
					[4,1],
					[4,2],
					[4,3],
					
					[5,1],
					[5,2],
					[5,3],
					
					[6,1],
					[6,2],
					[6,3],
					
					[7,1],
					[7,2],
					
					[8,1],
					[8,2],
					
					[9,1],
					[9,2],
					
					[10,1],
					
					[11,2],				
				],
				
				
				
				
				
				
				
				
				
				[//formation 1
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,6],
					[1,6],
					[2,6],
					[3,6],
					[4,6],
					[5,6],
					[6,6],
					[7,6],
					[8,6],
					[9,6],
					[10,6],
					[11,6],
					[12,6],
					[13,6],
					[14,6],
					[15,6],							
				],
				
				
				[//formation 2
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,9],
					[1,9],
					[2,9],
					[3,9],
					[4,9],
					[5,9],
					[6,9],
					[7,9],
					[8,9],
					[9,9],
					[10,9],
					[11,9],
					[12,9],
					[13,9],
					[14,9],
					[15,9],							
				],
				
				[//formation 3
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,12],
					[1,12],
					[2,12],
					[3,12],
					[4,12],
					[5,12],
					[6,12],
					[7,12],
					[8,12],
					[9,12],
					[10,12],
					[11,12],
					[12,12],
					[13,12],
					[14,12],
					[15,12],							
				],
				
				[//formation 4
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,15],
					[1,15],
					[2,15],
					[3,15],
					[4,15],
					[5,15],
					[6,15],
					[7,15],
					[8,15],
					[9,15],
					[10,15],
					[11,15],
					[12,15],
					[13,15],
					[14,15],
					[15,15],							
				],
				
				[//formation 5
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,18],
					[1,18],
					[2,18],
					[3,18],
					[4,18],
					[5,18],
					[6,18],
					[7,18],
					[8,18],
					[9,18],
					[10,18],
					[11,18],
					[12,18],
					[13,18],
					[14,18],
					[15,18],							
				],
				
				[//formation 6
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,21],
					[1,21],
					[2,21],
					[3,21],
					[4,21],
					[5,21],
					[6,21],
					[7,21],
					[8,21],
					[9,21],
					[10,21],
					[11,21],
					[12,21],
					[13,21],
					[14,21],
					[15,21],							
				],
				
				[//formation 7
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,24],
					[1,24],
					[2,24],
					[3,24],
					[4,24],
					[5,24],
					[6,24],
					[7,24],
					[8,24],
					[9,24],
					[10,24],
					[11,24],
					[12,24],
					[13,24],
					[14,24],
					[15,24],							
				],
				
				[//formation 8
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,27],
					[1,27],
					[2,27],
					[3,27],
					[4,27],
					[5,27],
					[6,27],
					[7,27],
					[8,27],
					[9,27],
					[10,27],
					[11,27],
					[12,27],
					[13,27],
					[14,27],
					[15,27],							
				],
				
				[//formation 9
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,30],
					[1,30],
					[2,30],
					[3,30],
					[4,30],
					[5,30],
					[6,30],
					[7,30],
					[8,30],
					[9,30],
					[10,30],
					[11,30],
					[12,30],
					[13,30],
					[14,30],
					[15,30],							
				],
				
				
				[//formation 10
					[0,0],
					[1,0],
					[2,0],
					[3,0],
					[4,0],
					[5,0],
					[6,0],
					[7,0],
					[8,0],
					[9,0],
					[10,0],
					[11,0],
					[12,0],
					[13,0],
					[14,0],
					[15,0],
					
					
					
					[0,33],
					[1,33],
					[2,33],
					[3,33],
					[4,33],
					[5,33],
					[6,33],
					[7,33],
					[8,33],
					[9,33],
					[10,33],
					[11,33],
					[12,33],
					[13,33],
					[14,33],
					[15,33],							
				],
				
			];
		
		public function generateAnimation():void
		{
			animation = new Array();
			for (var i:int=0;i<this.constanimation.length;i++)
			{//for each frame, calculate the centre of mass
				var centreOfMass:FlxPoint = new FlxPoint(0,0);
				for (var j:int=0;j<this.constanimation[i].length;j++)
				{
					centreOfMass.x+=this.constanimation[i][j][0];
					centreOfMass.y+=this.constanimation[i][j][1];
				}
				//average
				centreOfMass.x/=this.constanimation[i].length;
				centreOfMass.y/=this.constanimation[i].length;
				//popuate the new array
				animation.push(new Array());
				for (j=0;j<this.constanimation[i].length;j++)
				{
					const dist:Number=2;
					animation[i].push([dist*(this.constanimation[i][j][0]-centreOfMass.x),
									dist*(this.constanimation[i][j][1]-centreOfMass.y)]);
				}
			}
		}
		

		[Embed(source = "data/player.png")] public static var Image:Class;
		public function Player(X:Number, Y:Number)
		{
			super(X,Y);
			this.oldPoint = new FlxPoint(0,0);
			generateAnimation();
			this.drag=new FlxPoint(200,200);
			points = new FlxGroup();
			this.visible=false;			
			group = new FlxGroup;
			this.maxVelocity=new FlxPoint(60,40);
			time=0;
			offsets = new Vector.<FlxPoint>;
			savedPositions = new Vector.<FlxPoint>;
			for (var i:int=0;i<this.animation[0].length;i++)
			{
				offsets.push(new FlxPoint(11-this.animation[0][i][0],this.animation[0][i][1]));
				savedPositions.push(new FlxPoint(11-this.animation[0][i][0],this.animation[0][i][1]));
				var s:FlxSprite = new FlxSprite(x+11-animation[0][i][0],y+animation[0][i][1]);
				s.maxVelocity=new FlxPoint(100+i*10,100);				
				s.createGraphic(2,2,0xff000000);
				group.add(s);
			}
			frame=0;
			facing=FlxSprite.RIGHT;
			//this.moves=false;
		}
		
		public var facing:uint;
		public var time:Number;
		public var offsets:Vector.<FlxPoint>;
		public var savedPositions:Vector.<FlxPoint>;
		public var group:FlxGroup;
		public var jumping:Boolean;
		
		public var points:FlxGroup;
		
		//override public function collide(Object:FlxObject=null):Boolean
		//{
		//	return false;
		//}
		public var oldPoint:FlxPoint;
		
		public function backupPositions():void
		{
			for (var i:int=0;i<savedPositions.length;i++)
			{
				savedPositions[i].x=this.group.members[i].x;
				savedPositions[i].y=this.group.members[i].y;
			}
			oldPoint.x=this.x;
			oldPoint.y=this.y;
		}
		public function restorePositions():void
		{
			for (var i:int=0;i<savedPositions.length;i++)
			{
				this.group.members[i].x=savedPositions[i].x;
				this.group.members[i].y=savedPositions[i].y;
			}
			this.x=oldPoint.x;
			this.y=oldPoint.y;			
		}
		
		public function moveTowards(s:FlxSprite,t:FlxPoint):void
		{
			
			const rate:Number=120;
			//simple linear velocity
			s.velocity.x=(t.x-s.x);
			s.velocity.y=(t.y-s.y);
			var amount:Number = Math.sqrt(s.velocity.x*s.velocity.x+s.velocity.y*s.velocity.y);
			if (amount>0.001)
			{
				s.velocity.x *= rate/amount;
				s.velocity.y *= rate/amount;
			}
			
		}
		
		public function spawn():void
		{					
			for (var i:int=0;i<this.group.members.length;i++)
			{
				this.group.members[i].x=this.x+offsets[i].x;
				this.group.members[i].y=this.y+offsets[i].y;
			}			
		}
		
		public var frame:int;
		
		public function updateoffsets():void
		{
			if (this.facing==FlxSprite.LEFT)
			{
				for (var i:int=0;i<this.offsets.length;i++)
				{
					this.offsets[i].x=this.animation[this.frame][i][0];
					this.offsets[i].y=this.animation[this.frame][i][1];
				}
			}
			else
			{
				for (i=0;i<this.offsets.length;i++)
				{
					this.offsets[i].x=11-this.animation[this.frame][i][0];
					this.offsets[i].y=this.animation[this.frame][i][1];
				}
			}
		}
		
		public function reconcileoffsets():void
		{
			for (var i:int=0;i<this.offsets.length;i++)
			{
				var dx:Number = this.group.members[i].x-this.savedPositions[i].x;
				var dy:Number = this.group.members[i].y-this.savedPositions[i].y;
				
				if (Math.abs(dx)+Math.abs(dy)>0.001)
				{
					trace(dx,dy);
				}
				
				for (var j:int=0;j<this.offsets.length;j++)
				{
					if (i==j)
					{
						continue;
					}
					this.group.members[j].x-=dx;
					this.group.members[j].y-=dy;
				}
			}
		}
		
		override public function update():void
		{
			var toPlay:String;
		
			time+=FlxG.elapsed;
			
			toPlay="idle";
			
			for (var i:int=0;i<this.group.members.length;i++)
			{
				moveTowards(this.group.members[i],new FlxPoint(this.x+offsets[i].x,this.y+offsets[i].y));
			}
			
			if (FlxG.keys.LEFT)
			{
				this.facing=FlxSprite.LEFT;
				velocity.x-=5;
			}
			if (FlxG.keys.RIGHT)
			{
				this.facing=FlxSprite.RIGHT;
				velocity.x+=5;
			}
			
			if (FlxG.keys.UP)
			{
				//this.facing=FlxSprite.LEFT;
				velocity.y-=5;
			}
			if (FlxG.keys.DOWN)
			{
				//this.facing=FlxSprite.RIGHT;
				velocity.y+=5;
			}
			
			
			if ((Math.abs(velocity.y+velocity.x)>=10 && this.time>0.2) || this.time>0.4 || FlxG.keys.justPressed("ONE")||FlxG.keys.justPressed("TWO")||FlxG.keys.justPressed("THREE")||FlxG.keys.justPressed("FOUR")||FlxG.keys.justPressed("FIVE")||FlxG.keys.justPressed("SIX")||FlxG.keys.justPressed("SEVEN")||FlxG.keys.justPressed("EIGHT")||FlxG.keys.justPressed("NINE"))
			{
					this.time=0;
					if (FlxG.keys.ONE && GameState.collected[0])
					{
						this.frame=4;
						
						if (!GameState.sndWhale1.playing && GameState.sndWhale1._fadeInTimer<=0)
						{
														
							GameState.sndWhale1.fadeIn(0.4);
						}
						
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}					
					else if (FlxG.keys.TWO && GameState.collected[1])
					{
						this.frame=5;
						
						if (!GameState.sndWhale2.playing && GameState.sndWhale2._fadeInTimer<=0)
						{
														
							GameState.sndWhale2.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
						
						
					}		
					else if (FlxG.keys.THREE && GameState.collected[2])
					{
						this.frame=6;
						
						
						if (!GameState.sndWhale3.playing && GameState.sndWhale3._fadeInTimer<=0)
						{
														
							GameState.sndWhale3.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}		
					else if (FlxG.keys.FOUR && GameState.collected[3])
					{
						this.frame=7;
						
						if (!GameState.sndWhale4.playing && GameState.sndWhale4._fadeInTimer<=0)
						{
														
							GameState.sndWhale4.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}		
					else if (FlxG.keys.FIVE && GameState.collected[4])
					{
						this.frame=8;
						
						if (!GameState.sndWhale5.playing && GameState.sndWhale5._fadeInTimer<=0)
						{
														
							GameState.sndWhale5.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}		
					else if (FlxG.keys.SIX && GameState.collected[5])
					{
						this.frame=9;
						
						if (!GameState.sndWhale6.playing && GameState.sndWhale6._fadeInTimer<=0)
						{
														
							GameState.sndWhale6.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}		
					else if (FlxG.keys.SEVEN && GameState.collected[6])
					{
						this.frame=10;
						
						
						if (!GameState.sndWhale7.playing && GameState.sndWhale7._fadeInTimer<=0)
						{
														
							GameState.sndWhale7.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}		
					else if (FlxG.keys.EIGHT && GameState.collected[7])
					{
						this.frame=11;
						
						
						
						if (!GameState.sndWhale8.playing && GameState.sndWhale8._fadeInTimer<=0)
						{
														
							GameState.sndWhale8.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}		
					else if (FlxG.keys.NINE && GameState.collected[8])
					{
						this.frame=12;
						
						
						if (!GameState.sndWhale9.playing && GameState.sndWhale9._fadeInTimer<=0)
						{
														
							GameState.sndWhale9.fadeIn(0.4);
						}
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
					}
					else
					{
						this.frame=(frame+1)%4;
						
						
						
						if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
						{						
							GameState.sndWhale1.fadeOut(0.4);
						}
						if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
						{						
							GameState.sndWhale2.fadeOut(0.4);
						}
						if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
						{						
							GameState.sndWhale3.fadeOut(0.4);
						}
						if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
						{						
							GameState.sndWhale4.fadeOut(0.4);
						}
						if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
						{						
							GameState.sndWhale5.fadeOut(0.4);
						}
						if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
						{						
							GameState.sndWhale6.fadeOut(0.4);
						}
						if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
						{						
							GameState.sndWhale7.fadeOut(0.4);
						}
						if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
						{						
							GameState.sndWhale8.fadeOut(0.4);
						}
						if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
						{						
							GameState.sndWhale9.fadeOut(0.4);
						}
					}
					updateoffsets();
			}
			
			
			//update centre of mass
			
			var centreOfMass:FlxPoint = new FlxPoint(0,0);
			for (i=0;i<this.group.members.length;i++)
			{
				centreOfMass.x+=this.group.members[i].x;
				centreOfMass.y+=this.group.members[i].y;
			}
			//average
			centreOfMass.x/=this.group.members.length;
			centreOfMass.y/=this.group.members.length;
			/*
			if (Math.abs(centreOfMass.x-this.x)>20)
			{
				this.x=centreOfMass.x;
				//trace("correcting x");
			}
			if (Math.abs(centreOfMass.y-this.y)>4)
			{
				this.y=centreOfMass.y;
				//trace("correcting y");
			}
			
			for (i=0;i<this.group.members.length;i++)
			{
				if (Math.abs(centreOfMass.x+this.offsets[i].x-this.group.members[i].x)>20)
				{
					this.group.members[i].x=this.x+this.offsets[i].x;
					//trace("correcting x");
				}
				if (Math.abs(centreOfMass.y+this.offsets[i].y-this.group.members[i].y)>20)
				{
					this.group.members[i].y=this.y+this.offsets[i].y;
					//trace("correcting y");
				}
			}*/
				
			super.update();
			
		}
	}
	
}